"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var core_1 = require("@material-ui/core");
var utils_1 = require("../lib/utils");
var index_1 = require("./index");
var styles_1 = require("@material-ui/core/styles");
var types_1 = require("../state/types");
var reducer_1 = __importDefault(require("../state/reducer"));
var useStyles = styles_1.makeStyles(function (theme) {
    var _a;
    return styles_1.createStyles({
        controls: (_a = {
                display: 'flex',
                alignItems: 'center'
            },
            _a[theme.breakpoints.down('sm')] = {
                justifyContent: 'space-around',
            },
            _a),
        videoContainer: {
            backgroundColor: theme.palette.common.black,
            display: 'inline-block',
        },
        video: {
            width: function (props) { return props.width; },
            height: function (props) { return props.height; },
        },
        actions: {
            display: 'flex',
            flexDirection: 'column',
            alignItems: 'center',
            paddingTop: theme.spacing(1),
            paddingRight: theme.spacing(2),
            paddingLeft: theme.spacing(2),
            paddingBottom: theme.spacing(1),
            '&:last-child': {
                paddingBottom: theme.spacing(1),
            },
        },
        card: {
            display: 'flex',
            flexDirection: 'column',
        },
        cardContent: {
            display: 'flex',
            justifyContent: 'center',
        }
    });
});
var getInitialState = function (props) { return ({
    url: '',
    key: Math.random(),
    playing: false,
    time: {
        currentTime: 0,
        duration: 0,
    },
    fade: 1,
    width: props.width,
    height: (props.width || 0) * 9 / 16,
    playerTimeout: null,
}); };
var MaterialUIVideo = function (props) {
    var _a = react_1.useReducer(reducer_1.default, getInitialState(props)), state = _a[0], dispatch = _a[1];
    var player = react_1.useRef(null);
    var pausePlaying = react_1.useCallback(function () {
        player.current.pause();
        state.playerTimeout && clearInterval(state.playerTimeout);
        dispatch({ type: types_1.ActionType.PAUSE });
    }, [state.playerTimeout]);
    var setCurrentTime = react_1.useCallback(function (value) {
        var currentFade = utils_1.getFade(props.fadeSettings, player.current.duration, player.current.currentTime);
        var currentTime = value === undefined ?
            player.current.currentTime :
            (value / 100) * (player.current.duration || 0);
        if (value !== undefined) {
            player.current.currentTime = currentTime;
        }
        var progressTime = {
            currentTime: currentTime,
            duration: player.current.duration,
        };
        dispatch({
            type: types_1.ActionType.UPDATE_TIME,
            payload: {
                time: progressTime,
                fade: currentFade,
            }
        });
    }, [props.fadeSettings]);
    var setSize = react_1.useCallback(function () {
        var width = state.width || player.current.videoWidth;
        var height = state.width ?
            (player.current.videoHeight * width / player.current.videoWidth) :
            player.current.videoHeight;
        dispatch({
            type: types_1.ActionType.UPDATE_SIZE,
            payload: {
                width: width,
                height: height
            },
        });
    }, [state.width]);
    var src = props.src, _b = props.onEnded, onEnded = _b === void 0 ? function () { return setCurrentTime(0); } : _b, _c = props.onBackwardClick, onBackwardClick = _c === void 0 ? function () { } : _c, _d = props.onForwardClick, onForwardClick = _d === void 0 ? function () { } : _d, _e = props.loop, loop = _e === void 0 ? !!props.loop : _e, _f = props.autoplay, autoplay = _f === void 0 ? !!props.autoplay : _f;
    var classes = useStyles({ width: state.width, height: state.height });
    var onPlay = react_1.useCallback(function () { return __awaiter(void 0, void 0, void 0, function () {
        var videoUrl, _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    if (!!player.current.src) return [3 /*break*/, 4];
                    if (!(typeof src === 'string')) return [3 /*break*/, 1];
                    _a = src;
                    return [3 /*break*/, 3];
                case 1: return [4 /*yield*/, src];
                case 2:
                    _a = _b.sent();
                    _b.label = 3;
                case 3:
                    videoUrl = _a;
                    dispatch({
                        type: types_1.ActionType.UPDATE_URL,
                        payload: videoUrl,
                    });
                    player.current.src = videoUrl;
                    player.current.load();
                    player.current.onloadedmetadata = setSize;
                    _b.label = 4;
                case 4:
                    dispatch({
                        type: types_1.ActionType.PLAY,
                        payload: setInterval(function () {
                            setCurrentTime();
                        }, 50),
                    });
                    return [4 /*yield*/, player.current.play()];
                case 5:
                    _b.sent();
                    return [2 /*return*/];
            }
        });
    }); }, [src, setSize, setCurrentTime]);
    react_1.useEffect(function () {
        dispatch({
            type: types_1.ActionType.UPDATE_KEY,
            payload: Math.random(),
        });
    }, [src]);
    react_1.useEffect(function () {
        return function () {
            state.playerTimeout && clearInterval(state.playerTimeout);
        };
    }, [state.playerTimeout]);
    react_1.useEffect(function () {
        player.current.autoplay = autoplay;
        player.current.loop = loop;
        player.current.onended = function () {
            pausePlaying();
            onEnded();
        };
    }, [pausePlaying, onEnded, autoplay, loop]);
    react_1.useEffect(function () {
        autoplay && onPlay();
    }, [autoplay, onPlay]);
    var onProgressClick = react_1.useCallback(function (value) { return __awaiter(void 0, void 0, void 0, function () {
        var videoUrl, _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    if (!!player.current.src) return [3 /*break*/, 4];
                    if (!(typeof src === 'string')) return [3 /*break*/, 1];
                    _a = src;
                    return [3 /*break*/, 3];
                case 1: return [4 /*yield*/, src];
                case 2:
                    _a = _b.sent();
                    _b.label = 3;
                case 3:
                    videoUrl = _a;
                    dispatch({
                        type: types_1.ActionType.UPDATE_URL,
                        payload: videoUrl,
                    });
                    player.current.src = videoUrl;
                    player.current.load();
                    player.current.onloadedmetadata = function () { return setCurrentTime(value); };
                    return [2 /*return*/];
                case 4:
                    setCurrentTime(value);
                    return [2 /*return*/];
            }
        });
    }); }, [src, setCurrentTime]);
    var onStopClick = react_1.useCallback(function () {
        pausePlaying();
        setCurrentTime(0);
    }, [pausePlaying, setCurrentTime]);
    return (react_1.default.createElement(core_1.Card, { className: classes.card },
        react_1.default.createElement(core_1.CardContent, { className: classes.cardContent },
            react_1.default.createElement("div", { className: classes.videoContainer },
                react_1.default.createElement("video", { style: { opacity: state.fade }, ref: player, key: state.key, className: classes.video }, state.url && react_1.default.createElement("source", { type: utils_1.getMimeType(state.url), src: state.url })))),
        react_1.default.createElement(core_1.CardActions, { className: classes.actions },
            react_1.default.createElement(core_1.Grid, { container: true, justify: "center", alignItems: "center" },
                react_1.default.createElement(core_1.Grid, { item: true, xs: 12 },
                    react_1.default.createElement(index_1.Progress, { time: state.time, onProgressClick: function (v) { return __awaiter(void 0, void 0, void 0, function () { return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0: return [4 /*yield*/, onProgressClick(v)];
                                case 1: return [2 /*return*/, _a.sent()];
                            }
                        }); }); } })),
                react_1.default.createElement(core_1.Grid, { item: true, xs: 12, sm: 6 },
                    react_1.default.createElement("div", { className: classes.controls },
                        react_1.default.createElement(index_1.MediaTime, { time: state.time }),
                        react_1.default.createElement(index_1.ControlKeys, { onPauseClick: pausePlaying, onPlayClick: onPlay, backward: props.backward, forward: props.forward, playing: state.playing, onForwardClick: onForwardClick, onBackwardClick: onBackwardClick, onStopClick: onStopClick }))),
                props.speed &&
                    react_1.default.createElement(core_1.Grid, { item: true, xs: 6, sm: 3 },
                        react_1.default.createElement(index_1.SpeedBar, { player: player.current })),
                react_1.default.createElement(core_1.Grid, { item: true, xs: props.speed ? 6 : 12, sm: props.speed ? 3 : 6 },
                    react_1.default.createElement(index_1.VolumeBar, { player: player.current }))))));
};
exports.default = MaterialUIVideo;
//# sourceMappingURL=VideoCard.js.map