"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getFade = exports.getMimeType = exports.timeToString = exports.timeToPercentage = void 0;
var getTime = function (n) {
    var seconds = !Number.isFinite(n) ? 0 : Math.trunc(n);
    var dateString = new Date(seconds * 1000).toISOString();
    return seconds >= 3600 ? dateString.substr(11, 8) : dateString.substr(14, 5);
};
var timeToPercentage = function (time) { return time ? (time.currentTime / time.duration) * 100 : 0; };
exports.timeToPercentage = timeToPercentage;
var timeToString = function (time) { return getTime(time.currentTime) + "/" + getTime(time.duration); };
exports.timeToString = timeToString;
var getMimeType = function (url) {
    var mimeMap = {
        mid: 'audio/midi',
        midi: 'audio/midi',
        kar: 'audio/midi',
        mp3: 'audio/mpeg',
        ogg: 'audio/ogg',
        ra: 'audio/x-realaudio',
        '3gpp': 'video/3gpp',
        '3gp': 'video/3gpp',
        mpeg: 'video/mpeg',
        mpg: 'video/mpeg',
        mov: 'video/quicktime',
        flv: 'video/x-flv',
        mng: 'video/x-mng',
        asx: 'video/x-ms-asf',
        asf: 'video/x-ms-asf',
        wmv: 'video/x-ms-wmv',
        avi: 'video/x-msvideo',
        m4v: 'video/mp4',
        mp4: 'video/mp4',
    };
    return mimeMap[url.split(/[#?]/)[0].split('.').pop().trim()];
};
exports.getMimeType = getMimeType;
var getFade = function (settings, duration, currentTime) {
    if (!settings)
        return 1;
    var fadeOut = duration - currentTime;
    if (fadeOut <= settings.fadeOutTime) {
        return fadeOut / settings.fadeOutTime;
    }
    if (currentTime <= settings.fadeInTime) {
        return currentTime / settings.fadeInTime;
    }
    return 1;
};
exports.getFade = getFade;
//# sourceMappingURL=utils.js.map