import React from 'react';
interface PlayerSettings {
    onended: () => void;
    loop: boolean;
    autoplay: boolean;
}
export default class Player {
    ref: React.MutableRefObject<HTMLMediaElement | null>;
    constructor(ref: React.MutableRefObject<HTMLMediaElement | null>, settings: PlayerSettings);
    get duration(): number;
    get speed(): number;
    set speed(value: number);
    get currentTime(): number;
    set currentTime(value: number);
    get volume(): number;
    set volume(value: number);
    get src(): string;
    set src(value: string);
    get muted(): boolean;
    get paused(): boolean;
    set muted(value: boolean);
    get loop(): boolean;
    set loop(value: boolean);
    get autoplay(): boolean;
    set autoplay(value: boolean);
    set onMetadata(callback: () => void);
    set onended(callback: () => void);
    play(): void;
    pause(): void;
    load(): void;
}
export {};
